#ifndef RTW_HEADER_BCUDisp_h_
#define RTW_HEADER_BCUDisp_h_
#include "rtwtypes.h"

typedef uint8_T chrgSt;

#define noChrg                         ((chrgSt)0U)
#define chrging                        ((chrgSt)1U)
#define chrgEnd                        ((chrgSt)2U)
#define chrgFlt                        ((chrgSt)3U)

typedef uint8_T chgCnctObj;

#define vehicle                        ((chgCnctObj)0U)
#define chgStation                     ((chgCnctObj)1U)

extern real32_T damd_E_chrgEng;
extern real32_T damd_E_disChrgEng;
extern real32_T damd_E_regenEng;
extern real32_T damd_E_totalChrgEng;
extern real32_T damd_E_totalChrgEngEi;
extern real32_T damd_E_totalChrgEngEo;
extern real32_T damd_E_totalDisChrgEng;
extern real32_T damd_E_totalDisChrgEngEi;
extern real32_T damd_E_totalDisChrgEngEo;
extern real32_T damd_E_totalRegenEng;
extern real32_T damd_E_totalRegenEngEi;
extern real32_T damd_E_totalRegenEngEo;
extern real32_T damd_E_totalSatChrgEng;
extern real32_T damd_E_totalSatChrgEngEi;
extern real32_T damd_E_totalSatChrgEngEo;
extern real32_T damd_E_totalVehChrgEng;
extern real32_T damd_E_totalVehChrgEngEi;
extern real32_T damd_E_totalVehChrgEngEo;
extern uint16_T damd_Nr_totalChg;
extern uint16_T damd_Nr_totalChgEi;
extern uint16_T damd_Nr_totalChgEo;
extern uint16_T damd_Nr_totalStaChrg;
extern uint16_T damd_Nr_totalStaChrgEi;
extern uint16_T damd_Nr_totalStaChrgEo;
extern uint16_T damd_Nr_totalVehChrg;
extern uint16_T damd_Nr_totalVehChrgEi;
extern uint16_T damd_Nr_totalVehChrgEo;
extern real32_T damd_Q_chrgCp;
extern real32_T damd_Q_disChrgCp;
extern real32_T damd_Q_regenCp;
extern real32_T damd_Q_totalChrgCp;
extern real32_T damd_Q_totalChrgCpEi;
extern real32_T damd_Q_totalChrgCpEo;
extern real32_T damd_Q_totalDisChrgCp;
extern real32_T damd_Q_totalDisChrgCpEi;
extern real32_T damd_Q_totalDisChrgCpEo;
extern real32_T damd_Q_totalRegenCp;
extern real32_T damd_Q_totalRegenCpEi;
extern real32_T damd_Q_totalRegenCpEo;
extern real32_T damd_Q_totalSatChrgCp;
extern real32_T damd_Q_totalSatChrgCpEi;
extern real32_T damd_Q_totalSatChrgCpEo;
extern real32_T damd_Q_totalVehChrgCp;
extern real32_T damd_Q_totalVehChrgCpEi;
extern real32_T damd_Q_totalVehChrgCpEo;
extern uint8_T damd_st_chgCnctObjEi;
extern uint8_T damd_st_chgCnctObjEo;
extern chrgSt dcmd_st_chrgSt_T2;
extern chgCnctObj hvmd_st_chgCnctObj_T2;
extern real32_T ihd_I_battCurr_T2;
extern real32_T ihd_V_battU_T2;
extern real32_T ihd_V_cellUAvrg;
extern real32_T ihd_V_cellUMax;
extern real32_T ihd_V_cellUMin;
extern real32_T ihd_pct_socCor;
extern uint8_T ihd_tm_dayEi;
extern uint8_T ihd_tm_dayEo;
extern uint8_T ihd_tm_hourEi;
extern uint8_T ihd_tm_hourEo;
extern uint8_T ihd_tm_minEi;
extern uint8_T ihd_tm_minEo;
extern uint8_T ihd_tm_monthEi;
extern uint8_T ihd_tm_monthEo;
extern uint16_T ihd_tm_parkTime;
extern uint32_T ihd_tm_realTime;
extern uint8_T ihd_tm_secEi;
extern uint8_T ihd_tm_secEo;
extern uint8_T ihd_tm_yearEi;
extern uint8_T ihd_tm_yearEo;
extern boolean_T ihv_flg_EESt[4];
extern uint8_T rted_tm_day;
extern uint8_T rted_tm_hour;
extern uint8_T rted_tm_min;
extern uint8_T rted_tm_month;
extern uint8_T rted_tm_sec;
extern uint8_T rted_tm_year;
extern boolean_T rtev_flg_EESt[4];
extern real32_T socd_Q_dMax;
extern real32_T socd_Q_dMin;
extern boolean_T socd_flg_EEsave;
extern real32_T socd_pct_ahSoc;
extern real32_T socd_pct_battSoc;
extern real32_T socd_pct_battSocEi;
extern real32_T socd_pct_battSocEo;
extern real32_T socd_pct_bcuSoc;
extern real32_T socd_pct_bcuSocEi;
extern real32_T socd_pct_bcuSocEo;
extern real32_T socd_pct_ekfSoc;
extern real32_T sohd_pct_bcuSoh;

#endif
